import com.alibaba.fastjson.JSON;
import util.HttpClient;
import models.user.CreateUserRequest;

import static util.SignUtil.generateJWT;

public class IdaasApi {

    public static void main(String[] args) {
        String result;

        //获取人员列表
        result = getUserList();
        System.out.println(result);

        //创建人员
		CreateUserRequest user = new CreateUserRequest();
		user.setUsername("");
		user.setDisplayName("");
		user.setPrimaryMail("");
		user.setDeptId("");
		result = createUser(user);
		System.out.println(result);

        //删除人员
        result = deleteUser("");
        System.out.println(result);

    }

    public static String getUserList() {
        String jwtToken = generateJWT(IdaasApiConfig.kid, IdaasApiConfig.serviceAccount);
        String result;

        //获取人员列表
        result = HttpClient.doGet(IdaasApiConfig.httpUrl + "/api/v1/users", jwtToken, 200);
        return result;
    }

    public static String deleteUser(String userId) {
        String jwtToken = generateJWT(IdaasApiConfig.kid, IdaasApiConfig.serviceAccount);
        String result = HttpClient.doDelete(IdaasApiConfig.httpUrl + "/api/v1/users/" + userId, jwtToken, 204);
        return result;
    }

    public static String createUser(CreateUserRequest request) {
        String jwtToken = generateJWT(IdaasApiConfig.kid, IdaasApiConfig.serviceAccount);
        String body = JSON.toJSONString(request);
        //System.out.println(body);
        String result = HttpClient.doPost(IdaasApiConfig.httpUrl + "/api/v1/users", jwtToken, 201, body);
        return result;
    }
}
